{% extends 'base.html.twig' %}

{% block body %}
<main class='main-content bgc-grey-100 px-0'>

    {#<div id="studentVueTable">#}
    {#<vuetable ref="vuetable"#}
    {#:data="rowData"#}
    {#:api-mode="false"#}
    {#:per-page="20"#}
    {#api-url="{{ path("api_students", {'_format': 'json'}) }}"#}
    {#api-url="https://vuetable.ratiw.net/api/users"#}
    {#:fields="fields"#}
    {#:css="cssClasses"#}
    {#:sort-order="sortOrder"#}
    {#:multi-sort="true"#}
    {#multi-sort-key="shift"#}
    {#pagination-path="pagination"#}
    {#@vuetable:pagination-data="onPaginationData"#}
    {#>#}
    {#<template slot="actions" scope="props">#}
    {#<div class="custom-actions">#}
    {#<button class="btn btn-secondary"#}
    {#@click="onAction('view-item', props.rowData, props.rowIndex)">#}
    {#<i class="zoom icon"></i>#}
    {#</button>#}
    {#<a class="btn btn-primary" :href="'{{ path('student_edit', {id:'%studentId'}) }}'.replace('%25studentId', props.rowData.id)" target="_blank">#}
    {#@click="onAction('edit-item', props.rowData, props.rowIndex)">#}
    {#<i class="fa fa-edit"></i>#}
    {#</a>#}
    {#<button class="btn btn-danger"#}
    {#@click="onAction('delete-item', props.rowData, props.rowIndex)">#}
    {#<i class="delete icon"></i>#}
    {#</button>#}
    {#</div>#}
    {#</template>#}
    {#</vuetable>#}
    {#<vuetable-pagination ref="pagination" @vuetable-pagination:change-page="onChangePage" :css="paginationCssClasses"></vuetable-pagination>#}
    {#</div>#}

    {#<script type="text/javascript">#}
    {#Vue.config.devtools = true;#}
    {#data = JSON.parse('{{ students|json_encode()|e('js') }}');#}
    {#var studentVueTable = new Vue({#}
    {#el: "#studentVueTable",#}
    {#delimiters: ['${', '}'],#}
    {#data: {#}
    {#fields: [#}
    {#{title: 'checkbox', name: '__checkbox', titleClass: 'center aligned', dataClass:'center aligned'},#}
    {#{title: 'Codice Fiscale', name: 'fiscal_code'},#}
    {#{title: 'Cognome', name: 'lastname', sortField:'student.lastname'},#}
    {#{title: 'Nome', name: 'firstname', sortField:'student.firstname'},#}
    {#{title: 'Provider', name: 'provider.name', sortField:'provider.name'},#}
    {#{title: 'Gruppi', name: 'groups', sortField:'group.name'},#}
    {#{title: 'Email', name: 'email', sortField:'student.email'},#}
    {#{title: 'Username', name: 'username', sortField:'student.username'},#}
    {#{title: 'Password', name: 'starting_password'},#}
    {#{title: 'Modifica', name: '__slot:actions'}#}
    {#],#}
    {#sortOrder: [#}
    {#// {field: 'group.name', direction: 'asc'},#}
    {#{field: 'student.lastname', direction: 'asc'}#}
    {#],#}
    {#cssClasses: {#}
    {#tableClass: 'table table-striped table-bordered',#}
    {#ascendingIcon: 'fa fa-chevron-up',#}
    {#descendingIcon: 'fa fa-chevron-down',#}
    {#handleIcon: 'fa fa-menu-hamburger'#}
    {#},#}
    {#paginationCssClasses: {#}
    {#wrapperClass: "pagination pull-right",#}
    {#activeClass: "btn-primary",#}
    {#disabledClass: "disabled",#}
    {#pageClass: "btn btn-border",#}
    {#linkClass: "btn btn-border",#}
    {#icons: {#}
    {#first: "",#}
    {#prev: "",#}
    {#next: "",#}
    {#last: ""#}
    {#}#}
    {#}#}
    {#//                rowData: data#}
    {#},#}
    {#components: {#}
    {#'vuetable': Vuetable.Vuetable,#}
    {#'vuetable-pagination': Vuetable.VuetablePagination#}
    {#},#}
    {#methods: {#}
    {#onPaginationData: function (paginationData) {#}
    {#this.$refs.pagination.setPaginationData(paginationData)#}
    {#},#}
    {#onChangePage: function (page) {#}
    {#this.$refs.vuetable.changePage(page)#}
    {#}#}
    {#}#}
    {#});#}

    {#</script>#}

    {#<div id="studentTable" style="width: 100%; height:  500px" class="ag-bootstrap"></div>#}

    {#<script type="text/javascript">#}
    {#(function() {#}
    {#document.addEventListener('DOMContentLoaded', function() {#}

    {#var gridDiv = document.querySelector('#studentTable');#}

    {#var gridOptions = {#}
    {#columnDefs: [#}
    {#{headerName: 'Codice Fiscale', field: 'fiscalCode'},#}
    {#{headerName: 'Cognome', field: 'lastname', sort: 'asc'},#}
    {#{headerName: 'Nome', field: 'firstname'},#}
    {#{headerName: 'Provider', field: 'providerName'},#}
    {#{headerName: 'Gruppi', field: 'groups'},#}
    {#{headerName: 'Email', field: 'email'},#}
    {#{headerName: 'Username', field: 'username'},#}
    {#{headerName: 'Password', field: 'startingPassword'},#}
    {#{headerName: 'Azioni'}#}
    {#],#}
    {#enableSorting: true,#}
    {#enableFilter: true,#}
    {#rowSelection: 'multiple',#}
    {#};#}

    {#new agGrid.Grid(gridDiv, gridOptions);#}

    {#data = JSON.parse('{{ students|json_encode()|e('js') }}');#}

    {#gridOptions.api.setRowData(data);#}
    {#});#}

    {#})();#}
    {#</script>#}

    {#<div id="studentTable">#}
    {#<ag-grid-vue style="width: 100%; height: 350px;" class="ag-fresh"#}
    {#:gridOptions="gridOptions"#}
    {#:columnDefs="columnDefs"#}
    {#:rowData="rowData"#}

    {#:enableColResize="true"#}
    {#:enableSorting="true"#}
    {#:enableFilter="true"#}
    {#:groupHeaders="true"#}
    {#:suppressRowClickSelection="true"#}
    {#:toolPanelSuppressGroups="true"#}
    {#:toolPanelSuppressValues="true"#}
    {#rowHeight="22">#}
    {#</ag-grid-vue>#}


    {#</div>#}

    {#<script type="text/javascript">#}
    {#Vue.config.devtools = true;#}
    {#var syncComp = new Vue({#}
    {#el: "#studentTable",#}
    {#delimiters: ['${', '}'],#}
    {#data: {#}
    {#columnDefs: [#}
    {#{headerName: 'Codice Fiscale', field: 'fiscalCode'},#}
    {#{headerName: 'Cognome', field: 'lastname'},#}
    {#{headerName: 'Nome', field: 'firstname'},#}
    {#{headerName: 'Provider', field: 'providerName'},#}
    {#{headerName: 'Gruppi', field: 'groups'},#}
    {#{headerName: 'Email', field: 'email'},#}
    {#{headerName: 'Username', field: 'username'},#}
    {#{headerName: 'Password', field: 'startingpassword'},#}
    {#{headerName: 'Azioni'}#}
    {#],#}
    {#gridOptions: null,#}
    {#rowData: [#}
    {#{lastname: "Pippo", firstname: "Pluto"}#}
    {#]#}
    {#},#}
    {#components: {#}
    {#'ag-grid-vue': agGridVue.AgGridVue#}
    {#}#}
    {#});#}
    {#</script>#}

    <h1 class="ml-2">Studenti</h1>

    <div class="table-responsive">
        <table class="table table-striped table-hover">
            <thead>
            <tr>
                <th>Codice Fiscale</th>
                <th>Cognome</th>
                <th>Nome</th>
                <th>Provider</th>
                <th>Gruppi</th>
                <th>Email</th>
                <th>Username</th>
                {#<th>Password</th>#}
                <th>Azioni</th>
            </tr>
            </thead>
            <tbody>
            {% for entity in pagination %}
                <tr data-person-name="{{ entity.username }}" data-person-id="{{ entity.id }}">
                    <td>{{ entity.fiscalCode }}</td>
                    <td>{{ entity.lastname }}</td>
                    <td>{{ entity.firstname }}</td>
                    <td>{{ entity.provider.name }}</td>
                    <td>{{ entity.groups|join(', ') }}</td>
                    <td>{{ entity.email }}</td>
                    <td>{{ entity.username }}</td>
                    {#<td>{{ entity.startingpassword }}</td>#}
                    <td>
                        <a href="{{ path('student_edit', { 'id': entity.id }) }}" class="btn btn-primary">Modifica</a>
                        <div class="dropdown">
                            <button type="button" class="btn btn-secondary dropdown-toggle"
                                    data-toggle="dropdown"
                                    aria-haspopup="true" aria-expanded="false">
                                Azioni <span class="caret"></span>
                            </button>
                            <div class="dropdown-menu dropdown-menu-right">
                                <a href="#" class="dropdown-item showPersonDataBt">
                                    Visualizza i dati
                                </a>
                                <a href="#" class="dropdown-item resetPersonPasswordBt"
                                   data-person-pass="{{ entity.startingPassword }}">
                                    Reimposta la password
                                </a>
                                <a href="#" class="dropdown-item renewPersonPasswordBt">
                                    Crea una nuova password
                                </a>

{#                                {% if user.state=='not-active' %}#}
{#                                    <a href="#"  id="internetOn-{{ entity.id }}"#}
{#                                            class="dropdown-item internetOn" {{ (not entity.username)?"disabled" }}>#}
{#                                        <i class="ti-alarm-clock"></i> Attiva#}
{#                                    </a>#}
{#                                {% else %}#}
{#                                    <a id="internetEx-{{ entity.id }}" class="dropdown-item internetOn">#}
{#                                        <i class="ti-alarm-clock"></i> Estendi#}
{#                                    </a>#}
{#                                    <a href="{{ path('internetOffUser',{'providerId': provider.id, 'groupId': group.id, 'studentId': entity.id}) }}"#}
{#                                       class="btn btn-danger"#}
{#                                            {% if user.activedByOtherUser %} onclick="return confirm('Non sei stato tu ad abilitare questo studente. Sicuro di volerlo disattivare?')"{% endif %}#}
{#                                    >#}
{#                                        Disattiva#}
{#                                    </a>#}
{#                                {% endif %}#}

                            </div>
                        </div>
                    </td>
                </tr>
            {% endfor %}
            </tbody>
        </table>
    </div>

    <div class="row px-2">
        <div class="col-md-4 mb-1">
            <div class="navigation">
                {{ knp_pagination_render(pagination) }}
            </div>
        </div>
        <div class="col-md-4 text-md-center mb-1">
            <a href="{{ path('student_new') }}" class="btn btn-primary">Crea Nuovo Studente</a>
        </div>
        <div class="col-md-4 text-md-right mb-1">
            <form class="form-search" action="{{ path('student_list') }}">
                <div class="form-group">
                    <select style="width: inherit; display: inline;" id="providerId" name="providerId"
                            class="form-control mb-1">
                        <option value="-1">Tutti i provider</option>
                        {% for entity in providers %}
                            <option value="{{ entity.id }}"
                                    {{ ((providerId is defined) and (entity.id==providerId))?"selected" }}
                            >{{ entity.name }}</option>
                        {% endfor %}
                    </select>

                    <input type="text" style="width: inherit; display: inline;"
                           id="queryString" name="queryString" class="form-control" placeholder="Cerca"
                           value="{{ queryString|escape('html') }}">
                    <button class="btn btn-secondary" type="submit"><i class="ti-search"></i></button>
                </div>
            </form>
        </div>
    </div>
</main>
{#    {% include 'components/student_activation_modal.html.twig' %}#}
    {% include 'components/user_actions_modal.html.twig' with {personType: 'student'} %}

{% endblock %}

{% block javascripts %}
    {{ parent() }}
    <script>
{#        {% include 'components/student_activation_modal.js.twig' %}#}
        {% include 'components/user_actions_modal.js.twig' with {personType: 'student'} %}
    </script>
    {#<script type="text/javascript" src="{{ asset('assets/vendor/vue/dist/vue.min.js') }}"></script>#}
    {#<script type="text/javascript" src="{{ asset('assets/vendor/vue-resource/dist/vue-resource.min.js') }}"></script>#}
    {#<script type="text/javascript" src="{{ asset('assets/vendor/ag-grid/dist/ag-grid.min.js') }}"></script>#}
    {#<script type="text/javascript" src="{{ asset('assets/vendor/ag-grid-vue/dist/ag-grid-vue.js') }}"></script>#}
    {#<script type="text/javascript" src="{{ asset('assets/vendor/vuetable-2/dist/vuetable-2.js') }}"></script>#}
    {#Vue.use(Vuetable)#}
    <script type="text/javascript">
        //        Vue.config.devtools = true;
    </script>
{% endblock %}

{% block stylesheets %}
    {{ parent() }}
    {#<link rel="stylesheet" href="{{ asset('assets/vendor/ag-grid/dist/styles/ag-grid.css') }}" media="screen">#}
{% endblock %}